/* -*- Mode: Java; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *
 * The contents of this file are subject to the Netscape Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/NPL/
 *
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 * The Original Code is mozilla.org code.
 *
 * The Initial Developer of the Original Code is Netscape
 * Communications Corporation.  Portions created by Netscape are
 * Copyright (C) 1998 Netscape Communications Corporation. All
 * Rights Reserved.
 *
 * Contributor(s): smorrison@gte.com
 *   Terry Hayes <thayes@netscape.com>
 *   Daniel Brooks <db48x@yahoo.com>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or 
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the NPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the NPL, the GPL or the LGPL.
*/

// mmm, yummy. global variables.
var thewindow = null;
var thedocument = null;

var linklist = new Array();
var formlist = new Array();
var imagelist = new Array();

var linkindex = 0;
var formindex = 0;
var imageindex = 0;
var framecount = 0;

// a number of services I'll need later
// the cache services
const nsICacheService = Components.interfaces.nsICacheService;
const cacheservice = Components.classes["@mozilla.org/network/cache-service;1"].getService(nsICacheService);
var httpcachesession = cacheservice.createSession("HTTP", 0, true);
var ftpcachesession = cacheservice.createSession("FTP", 0, true);

// scriptable date formater, for pretty printing dates
const nsIScriptableDateFormat = Components.interfaces.nsIScriptableDateFormat;
var dateService = Components.classes["@mozilla.org/intl/scriptabledateformat;1"].getService(nsIScriptableDateFormat);

// namespaces, don't need all of these yet...
const XLinkNS = "http://www.w3.org/1999/xlink";
const XULNS   = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";
const XMLNS   = "http://www.w3.org/XML/1998/namespace";
const XHTMLNS = "http://www.w3.org/1999/xhtml";

/* Overlays register init functions here.
 *   Add functions to call by invoking "onLoadRegistry.append(XXXLoadFunc);"
 *   The XXXLoadFunc should be unique to the overlay module, and will be
 *   invoked as "XXXLoadFunc();"
 */
var onLoadRegistry = [ ];
 
/* Called when PageInfo window is loaded.  Arguments are:
*   window.arguments[0] - document to use for source (null=Page Info, otherwise Frame Info)
*   window.arguments[1] - tab name to display first (may be null)
*/
function onLoadPageInfo()
{
  //dump("===============================================================================\n");
  var thebundle = document.getElementById("pageinfobundle");
  var unknown = thebundle.getString("unknown");

  var docTitle = "";
  if("arguments" in window && window.arguments.length >= 1 && window.arguments[0])
  {
    thewindow = null;
    thedocument = window.arguments[0];
    docTitle = thebundle.getString("frameInfo.title");
  } 
  else 
  {
    thewindow = window.opener.frames[0];
    thedocument = thewindow.document;
    docTitle = thebundle.getString("pageInfo.title");
  }

  document.title = docTitle;

  // do the easy stuff first
  makeGeneralTab();

  /* Call registered overlay init functions */
  for (x in onLoadRegistry)
  {
    onLoadRegistry[x]();
  }

  /* Select the requested tab, if the name is specified */
  if ("arguments" in window && window.arguments.length > 1) {
    var tabName = window.arguments[1];

    if (tabName)
    {
      var tabControl = document.getElementById("tabcontrol");
      var tab = document.getElementById(tabName);

      if (tabControl && tab) {
        tabControl.selectedTab = tab;
      }
    }
  }
}

function makeGeneralTab()
{
  var thebundle = document.getElementById("pageinfobundle");
  var unknown = thebundle.getString("unknown");
  
  var title = thebundle.getFormattedString("pageTitle", [thedocument.title]) || thebundle.getString("noPageTitle");
  document.getElementById("titletext").value = title;

  var url = thedocument.location;
  document.getElementById("urltext").value = url;

  var mode = ("compatMode" in thedocument && thedocument.compatMode == "BackCompat") ? thebundle.getString("generalQuirksMode") : thebundle.getString("generalStrictMode");
  document.getElementById("modetext").value = mode;

  // find out the mime type
  var mimetype = thedocument.contentType || unknown;
  document.getElementById("typetext").value = mimetype;
  
  // get the meta tags
  var metanodes = thedocument.getElementsByTagName("meta");
  var metaoutliner = document.getElementById("metaoutliner");
  var metaview = new pageInfoOutlinerView(["meta-name","meta-content"]);

  metaoutliner.outlinerBoxObject.view = metaview;

  var length = metanodes.length;
  for (var i = 0; i < length; i++)
  {    
    metaview.addRow([metanodes[i].name || metanodes[i].httpEquiv, metanodes[i].content]);
  }
  metaview.rowCountChanged(0, length);
  
  // get the document characterset
  var encoding = thedocument.characterSet;
  document.getElementById("encodingtext").value = encoding;

  // get the date of last modification
  var modifiedtext = formatDate(thedocument.lastModified, unknown);
  document.getElementById("modifiedtext").value = modifiedtext;
  
  // get cache info
  var sourcetext = thebundle.getString("generalNotCached");
  var expirationtext = thebundle.getString("generalNoExpiration");
  var sizetext = unknown;

  var pagesize = 0; 
  var kbsize = 0;
  var expirationtime = 0;

  try
  {
    var cacheentrydescriptor = httpcachesession.openCacheEntry(url, Components.interfaces.nsICache.ACCESS_READ, true);
    if(cacheentrydescriptor)
    { 
      switch(cacheentrydescriptor.deviceID)
      {
        case "disk":
          sourcetext = thebundle.getString("generalDiskCache");
          break;
        case "memory":
          sourcetext = thebundle.getString("generalMemoryCache");
          break;
        default:
          sourcetext = cacheentrydescriptor.deviceID;
          break;
      }

      pagesize = cacheentrydescriptor.dataSize;
      kbsize = pagesize / 1024;
      sizetext = pagesize; // + " (" + 0 + "Kb)";

      expirationtext = formatDate(cacheentrydescriptor.expirationTime*1000);
    }
  }
  catch(ex)
  {
    try
    {
      cacheentrydescriptor = ftpcachesession.openCacheEntry(url, Components.interfaces.nsICache.ACCESS_READ, true);
      if (cacheentrydescriptor)
      {
        switch(cacheentrydescriptor.deviceID)
        {
          case "disk":
            sourcetext = thebundle.getString("generalDiskCache");
            break;
          case "memory":
            sourcetext = thebundle.getString("generalMemoryCache");
            break;
          default:
            sourcetext = cacheentrydescriptor.deviceID;
            break;
        }

        pagesize = cacheentrydescriptor.dataSize;
        kbsize = pagesize / 1024;
        sizetext = pagesize; // + " (" + 0 + "Kb)";

        expirationtext = formatDate(cacheentrydescriptor.expirationTime*1000);
      }
    }
    catch(ex2)
    {
      sourcetext = thebundle.getString("generalNotCached");
    }
  }
  document.getElementById("sourcetext").value = sourcetext;
  document.getElementById("expirestext").value = expirationtext;
  document.getElementById("sizetext").value = sizetext;
}

//******** Form Stuff
function makeFormTab()
{
  var formoutliner = document.getElementById("formoutliner");
  var formpreview = document.getElementById("formpreview");
  
  var formview = new pageInfoOutlinerView(["form-number","form-name","form-action","form-method"]);
  var fieldview = new pageInfoOutlinerView(["field-number","field-label","field-field","field-type","field-value"]);
  formoutliner.outlinerBoxObject.view = formview;
  formpreview.outlinerBoxObject.view = fieldview;

  formlist = grabAllForms(thewindow, thedocument);
  formindex = 0;

  var length = formlist.length;
  for (var i = 0; i < length; i++)
  {
    var elem = formlist[i];
    formview.addRow([++formindex, elem.name, elem.method, elem.action]);
  }
  formview.rowCountChanged(0, length);

  formview.selection.select(0);
}

function grabAllForms(awindow, adocument)
{
  var thelist = [];

  if (awindow && awindow.frames.length > 0)
  {
    var length = awindow.frames.length;
    for (var i = 0; i < length; i++)
    {
      var frame = awindow.frames[i];
      thelist = thelist.concat(grabAllForms(frame, frame.document));
    }
  }

  return thelist.concat(adocument.forms);
}

function onFormSelect()
{
  var thebundle = document.getElementById("pageinfobundle");
  var formoutliner = document.getElementById("formoutliner");
  var formview = formoutliner.outlinerBoxObject.view;

  if (formview.selection.count == 1)
  {
    var formpreview = document.getElementById("formpreview");
    var fieldview = new pageInfoOutlinerView(["field-number","field-label","field-field","field-type","field-value"]);
    formpreview.outlinerBoxObject.view = fieldview;

    var clickedRow = formview.selection.currentIndex;
    var formnum = formview.getCellText(clickedRow, "form-number");
    var form = formlist[formnum-1];
    var ft = null;
    if (form.name)
      ft = thebundle.getFormattedString("formTitle", [form.name]);
    else
      ft = thebundle.getString("formUntitled");

    document.getElementById("formname").value = ft || thebundle.getString("formUntitled");
    document.getElementById("formenctype").value = form.encoding || thebundle.getString("default");
    document.getElementById("formtarget").value = form.target || thebundle.getString("formDefaultTarget");

    var formfields = form.elements;

    var length = formfields.length;
    var i = 0;

    var checked = thebundle.getString("formChecked");
    var unchecked = thebundle.getString("formUnchecked");    

    for (i = 0; i < length; i++)
    {
      var elem = formfields[i];

      if(elem.nodeName.toLowerCase() == "button")
        fieldview.addRow([i+1, "", elem.name, elem.type, getValueText(elem)]);
      else
        fieldview.addRow([i+1, "", elem.name, elem.type, elem.value]);
    }

    var labels = form.getElementsByTagName("label");
    var llength = labels.length

    for (i = 0; i < llength; i++)
    {
      var whatfor = labels[i].getAttribute("for") || findFirstControl(labels[i]);
      var labeltext = getValueText(labels[i]);

      for(var j = 0; j < length; j++)
        if (formfields[j] == whatfor || formfields[j].name == whatfor)
          fieldview.setCellText(j, "field-label", labeltext);
    }

    fieldview.rowCountChanged(0, length);
  }
}

function findFirstControl(node)
{
  function FormControlFilter() 
  {
    this.acceptNode = function(node)
    {
      switch (node.nodeName.toLowerCase())
      {
        case "input":
        case "select":
        case "button":
        case "textarea":
        case "object":
          return NodeFilter.FILTER_ACCEPT;
          break;
        default:
          return NodeFilter.FILTER_SKIP;
          break;
      }
      return NodeFilter.FILTER_SKIP;   // placate the js compiler
    }     
  }

  var nodefilter = new FormControlFilter;
  var iterator = thedocument.createTreeWalker(node, NodeFilter.SHOW_ELEMENT, nodefilter, true);

  return iterator.nextNode();
}

//******** Link Stuff
function makeLinkTab()
{
  var start = new Date();
  var thebundle = document.getElementById("pageinfobundle");
  var linkoutliner = document.getElementById("linkoutliner");

  var linkview = new pageInfoOutlinerView(["link-number","link-name","link-address","link-type"]);
  linkoutliner.outlinerBoxObject.view = linkview;

  linklist = grabAllLinks(thewindow, thedocument);

  var linkAnchor = thebundle.getString("linkAnchor");
  var linkArea = thebundle.getString("linkArea");
  var linkSubmit = thebundle.getString("linkSubmit");
  var linkSubmission = thebundle.getString("linkSubmission");
  var linkRel = thebundle.getString("linkRel");
  var linkStylesheet = thebundle.getString("linkStylesheet");
  var linkRev = thebundle.getString("linkRev");

  var linktext = null;
  linkindex = 0;

  var length = linklist.length;
  for (var i = 0; i < length; i++)
  {
    var elem = linklist[i];
    switch (elem.nodeName.toLowerCase())
    {
      case "a":
        linktext = getValueText(elem);
        linkview.addRow([++linkindex, linktext, elem.href, linkAnchor]);
        break;
      case "area":
        linkview.addRow([++linkindex, elem.alt, elem.href, linkArea]);
        break;
      case "input":
        linkview.addRow([++linkindex, elem.value || linkSubmit, elem.form.action, linkSubmission]);
        break;
      case "link":
        if (elem.rel)
        {
          // should this test use regexes to be a little more lenient wrt whitespace?
          if (elem.rel.toLowerCase() == "stylesheet" || elem.rel.toLowerCase() == "alternate stylesheet")
            linktext = linkStylesheet;
          else
            linktext = linkRel;
        }
        else
          linktext = linkRev;
        linkview.addRow([++linkindex, elem.rel || elem.rev, elem.href, linktext]);
        break;
      default:
        dump("Page Info - makeLinkTab(): Hey, that's an odd one! ("+elem+")");
        break;
    }
  }
  linkview.rowCountChanged(0, length);

  var end = new Date();
  dump("links tab took "+(end-start)+"ms to build.\n");
}

function grabAllLinks(awindow,adocument)
{
  var thelist = [];

  if (awindow && awindow.frames.length > 0)
  {
    var num = awindow.frames.length;
    for (var i = 0; i < num; i++)
    {
      var frame = awindow.frames[i];
      thelist = thelist.concat(grabAllLinks(frame, frame.document));
    }
  }

  thelist = thelist.concat(adocument.getElementsByTagName("link"));

  var inputlist = adocument.getElementsByTagName("input");
  var length = inputlist.length;
  for (i = 0; i < length; i++)
    if (inputlist[i].type.toLowerCase() == "submit")
      thelist = thelist.concat(inputlist[i]);

  return thelist.concat(adocument.links);
}

function openURL(target)
{
  var url = target.parentNode.childNodes[2].value;
  window.open(url, "_blank", "chrome");
}

//******** Image Stuff
function makeMediaTab()
{
  var thebundle = document.getElementById("pageinfobundle");
  var imageoutliner = document.getElementById("imageoutliner");

  var imageview = new pageInfoOutlinerView(["image-number","image-address","image-type"]);
  imageoutliner.outlinerBoxObject.view = imageview;

  imagelist = grabAllMedia(thewindow, thedocument);

  var mediaImg = thebundle.getString("mediaImg");
  var mediaApplet = thebundle.getString("mediaApplet");
  var mediaObject = thebundle.getString("mediaObject");
  var mediaEmbed = thebundle.getString("mediaEmbed");
  var mediaLink = thebundle.getString("mediaLink");

  var row = null;
  var length = imagelist.length;
  imageindex = 0;

  for (var i = 0; i < length; i++)
  {
    var elem = imagelist[i];
    switch (elem.nodeName.toLowerCase())
    {
      case "img":
        imageview.addRow([++imageindex, elem.src, mediaImg]);
        break;
      case "applet":
        imageview.addRow([++imageindex, elem.code || elem.object, mediaApplet]);
        break;
      case "object":
        imageview.addRow([++imageindex, elem.data, mediaObject]);
        break;
      case "embed":
        imageview.addRow([++imageindex, elem.src, mediaEmbed]);
        break;
      case "link":
        imageview.addRow([++imageindex, elem.href, mediaLink]);
        break;
      default:
        dump("Page Info - makeMediaTab(): hey, that's an odd one! ("+elem+")");;
        break;
    }
  }
  imageview.rowCountChanged(0, length);
  
  imageview.selection.select(0);
}

function grabAllMedia(awindow, adocument)
{
  var thelist = [];

  if (awindow && awindow.frames.length > 0)
  {
    var num = awindow.frames.length;
    for (var i = 0; i < num; i++)
    {
      var frame = awindow.frames[i];
      thelist = thelist.concat(grabAllMedia(frame, frame.document));
    }
  }

  thelist = thelist.concat(adocument.getElementsByTagName("embed"), adocument.applets, adocument.getElementsByTagName("object"));

  var inputlist = adocument.getElementsByTagName("input");
  var length = inputlist.length
  for (i = 0; i < length; i++)
    if(inputlist[i].type.toLowerCase() == "image")
      thelist = thelist.concat(inputlist[i]);

  var linklist = adocument.getElementsByTagName("link");
  length = linklist.length;
  for (i = 0; i < length; i++)
    if(linklist[i].rel.toLowerCase() == "icon")
      thelist = thelist.concat(linklist[i]);

  return thelist.concat(adocument.images);
}  

function onImageSelect()
{
  var outliner = document.getElementById("imageoutliner");
  var preview = document.getElementById("imagepreview");

  if (outliner.outlinerBoxObject.selection.count == 1)
  {
    var clickedRow = outliner.outlinerBoxObject.selection.currentIndex;
    var linenum = outliner.outlinerBoxObject.view.getCellText(clickedRow, "image-number");;

    makePreview(imagelist[linenum-1]);
  }
}

function makePreview(item)
{
  var thebundle = document.getElementById("pageinfobundle");
  var unknown = thebundle.getString("unknown");

  var notset = thebundle.getString("notset");

  var url = unknown; 
    url = ("src" in item && item.src) || ("code" in item && item.code) || ("data" in item && item.data) || ("href" in item && item.href) || unknown;  // it better have at least one of those...
  document.getElementById("imageurltext").value = url;
  document.getElementById("imagetitletext").value = item.title || notset;
  document.getElementById("imagelongdesctext").value = ("longDesc" in item && item.longDesc) || notset;

  // find out the mime type
  var mimetype = unknown;
  if (item.nodeName.toLowerCase() != "input")
    mimetype = ("type" in item && item.type) || ("codeType" in item && item.codeType) || ("contentType" in item && item.contentType) || unknown;
  document.getElementById("imagetypetext").value = mimetype;

  // get cache info
  var sourcetext = thebundle.getString("generalNotCached");
  var expirationtext = thebundle.getString("unknown");
  var sizetext = thebundle.getString("unknown");

  var expirationtime = 0;
  var expirationdate = null;

  try
  {
    var cacheentrydescriptor = httpcachesession.openCacheEntry(url, Components.interfaces.nsICache.ACCESS_READ, true);   // open for READ, in blocking mode
    if (cacheentrydescriptor)
    {
      switch(cacheentrydescriptor.deviceID)
      {
        case "disk":
          sourcetext = thebundle.getString("generalDiskCache");
          break;
        case "memory":
          sourcetext = thebundle.getString("generalMemoryCache");
          break;
        default:
          sourcetext = cacheentrydescriptor.deviceID;
          break;
      }

      sizetext = cacheentrydescriptor.dataSize;

      expirationtext = formatDate(cacheentrydescriptor.expirationTime*1000);
    }
  }
  catch(ex)
  {
    try
    {
      cacheentrydescriptor = ftpcachesession.openCacheEntry(url, Components.interfaces.nsICache.ACCESS_READ, true);   // open for READ, in blocking mode
      if (cacheentrydescriptor)
      {
        switch(cacheentrydescriptor.deviceID)
        {
          case "disk":
            sourcetext = thebundle.getString("generalDiskCache");
            break;
          case "memory":
            sourcetext = thebundle.getString("generalMemoryCache");
            break;
          default:
            sourcetext = cacheentrydescriptor.deviceID;
            break;
        }

        sizetext = cacheentrydescriptor.dataSize;

        expirationtext = formatDate(cacheentrydescriptor.expirationTime*1000);
      }
    }
    catch(ex2)
    {
      sourcetext = thebundle.getString("generalNotCached");
    }
  }
  document.getElementById("imagesourcetext").value = sourcetext;
  document.getElementById("imageexpirestext").value = expirationtext;
  document.getElementById("imagesizetext").value = sizetext;

  // perhaps these can be done in the future
  //document.getElementById("imageplugintext").value = "--";
  //document.getElementById("imagecharsettext").value = "--";

  document.getElementById("imagewidth").value = ("width" in item && item.width) || unknown;
  document.getElementById("imageheight").value = ("height" in item && item.height) || unknown;

  // also can't be done at the moment
  //document.getElementById("imageencryptiontext").value = "--";

  var imagecontainer = document.getElementById("theimagecontainer");
  var oldimage = document.getElementById("thepreviewimage");

  var newimage = null;
  if (item.nodeName.toLowerCase() == "link")
  {
    newimage = document.createElementNS("http://www.w3.org/1999/xhtml", "IMG");
    newimage.src = getAbsoluteURL(item.href, item);
  }
  else
  {
    newimage = item.cloneNode(true);
    newimage.src = ("src" in item && item.src) || ("href" in item && item.href);  // weird funky hack, I know :P
  }

  newimage.setAttribute("id", "thepreviewimage");
  newimage.width = ("width" in item && item.width) || unknown;
  newimage.height = ("height" in item && item.height) || unknown;
  newimage.removeAttribute("align"); // just in case.

  imagecontainer.removeChild(oldimage);
  imagecontainer.appendChild(newimage);
}


//******** Other Misc Stuff
// Modified from the Links Panel v2.3, http://segment7.net/mozilla/links/links.html
// parse a node to extract the contents of the node
// linkNode doesn't really _have_ to be link
function getValueText(linkNode)
{
  var valueText = "";
  
  var length = linkNode.childNodes.length;
  for (var i = 0; i < length; i++)
  {
    var childNode = linkNode.childNodes[i];
    var nodeType = childNode.nodeType;
    if (nodeType == Node.TEXT_NODE)
      valueText += " " + childNode.nodeValue;
    else if (nodeType == Node.ELEMENT_NODE)
    {
      if (childNode.nodeName.toLowerCase() == "img")
        valueText += " " + getAltText(childNode);
      else
        valueText += " " + getValueText(childNode);
    }
  }

  return stripWS(valueText);
}

// Copied from the Links Panel v2.3, http://segment7.net/mozilla/links/links.html
// traverse the tree in search of an img or area element and grab its alt tag
function getAltText(node)
{
  var altText = "";
  
//  if (node.title)
//    return node.title;
  if (node.alt)
    return node.alt;
  var length = node.childNodes.length;
  for (var i = 0; i < length; i++)
    if ((altText = getAltText(node.childNodes[i]) != undefined))  // stupid js warning...
      return altText;
  return "";
}

// Copied from the Links Panel v2.3, http://segment7.net/mozilla/links/links.html
// strip leading and trailing whitespace, and replace multiple consecutive whitespace characters with a single space
function stripWS(text)
{
  var middleRE = /\s+/g;
  var endRE = /(^\s+)|(\s+$)/g;

  text = text.replace(middleRE, " ");
  return text.replace(endRE, "");
}

function formatDate(datestr, unknown)
{
  var date = new Date(datestr);
  return (date.milliseconds) ? dateService.FormatDateTime("", dateService.dateFormatLong, dateService.timeFormatSeconds, date.getFullYear(), date.getMonth()+1, date.getDate(), date.getHours(), date.getMinutes(), date.getSeconds()) : unknown;
}

/*
 * Takes care of XMLBase and <base>
 * url is the possibly relative url.
 * node is the node where the url was given (needed for XMLBase)
 *
 * This function is called in many places as a workaround for bug 72524
 * Once bug 72522 is fixed this code should use the Node.baseURI attribute
 *
 * for node==null or url=="", empty string is returned
 *
 * This is basically just copied from http://lxr.mozilla.org/seamonkey/source/xpfe/browser/resources/content/metadata.js
 */

function getAbsoluteURL(url, node)
{
  if (!url || !node)
    return "";
  var urlArr = new Array(url);

  var doc = node.ownerDocument;
  if (node.nodeType == Node.ATTRIBUTE_NODE)
    node = node.ownerElement;

  while (node && node.nodeType == Node.ELEMENT_NODE) 
  {
    var att = node.getAttributeNS(XMLNS, "base");
    if (att != "")
      urlArr.unshift(att);

    node = node.parentNode;
  }

  // Look for a <base>.
  var baseTags = doc.getElementsByTagNameNS(XHTMLNS, "base");

  if (baseTags && baseTags.length) 
  {
    urlArr.unshift(baseTags[baseTags.length - 1].getAttribute("href"));
  }

  // resolve everything from bottom up, starting with document location
  var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
  var URL = ioService.newURI(doc.location.href, null);

  for (var i=0; i<urlArr.length; i++) 
  {
    URL.spec = URL.resolve(urlArr[i]);
  }

  return URL.spec;
}

//******** define a js object to implement nsIOutlinerView
function pageInfoOutlinerView(columnids)
{
  // columnids is an array of strings indicating the names of the columns, in order
  this.columnids = columnids;
  this.colcount = columnids.length
  this.rowcount = 0;
  this.outliner = null;
  this.data = new Array;
  this.selection = null;
  this.selectioncallback = null;
}

pageInfoOutlinerView.prototype = {
  set rowCount(c) { throw "rowCount is a readonly property"; },
  get rowCount() { return this.rowcount; },

  setOutliner: function(outliner) 
  {
    this.outliner = outliner;
  },

  getCellText: function(row, column)
  {
    var colidx = 0;
    // loop through the list of column names to find the index to the column the should be worrying about. very much a hack, but what can you do?
    while(colidx < this.colcount && column != this.columnids[colidx])
      colidx++;
    return this.data[row][colidx];
  },

  setCellText: function(row, column, value) 
  {
    var colidx = 0;
    // loop through the list of column names to find the index to the column the should be worrying about. very much a hack, but what can you do?
    while(colidx < this.colcount && column != this.columnids[colidx])
      colidx++;
    this.data[row][colidx] = value;
  },

  addRow: function(row)
  {
    var oldrowcount = this.rowcount;
    this.rowcount = this.data.push(row);
  },

  addRows: function(rows)
  {
    var oldrowcount = this.rowCount;

    var length = rows.length;
    for(var i = 0; i < length; i++)
      this.rowcount = this.data.push(rows[i]);
  },

  rowCountChanged: function(index, count)
  {
    this.outliner.rowCountChanged(index, count);
  },

  invalidate: function()
  {
    this.outliner.invalidate();
  },

  clear: function()
  {
    this.data = null;
  },

  getRowProperties: function(row, column, prop) { },
  getCellProperties: function(row, prop) { },
  getColumnProperties: function(column, elem, prop) { },
  isContainer: function(index) { return false; },
  isContainerOpen: function(index) { return false; },
  isSeparator: function(index) { return false; },
  isSorted: function() { return false; },
  canDropOn: function(index) { return false; },
  canDropBeforeAfter: function(index, before) { return false; },
  drop: function(row, orientation) { return false; },
  getParentIndex: function(index) { return 0; },
  hasNextSibling: function(index, after) { return false; },
  getLevel: function(index) { return 0; },
  toggleOpenState: function(index) { },
  cycleHeader: function(col, elem) { },
  selectionChanged: function() { },
  cycleCell: function(row, column) { },
  isEditable: function(row, column) { return false; },
  performAction: function(action) { },
  performActionOnRow: function(action, row) { },
  performActionOnCell: function(action, row, column) { }
};